#include<bits/stdc++.h>
using namespace std;

int n;

int ans[100005];

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n;

    for(int i = 0; i < n-1; i++){
        int p, c;
        cin >> p >> c;
        ans[p]+= ans[c]+1;
    }

    int q;
    cin >> q;
    for(int i = 0; i < q; i++){
        int cq;
        cin >> cq;
        cout << ans[cq] << "\n";
    }

    return 0;
}
